$Apptype CONSOLE
$TYPECHECK ON
$OPTIMIZE ON
$OPTION Icon "gpslog.ico"
$INCLUDE "RAPIDQ.INC"
$INCLUDE "COMPORT.CMP"
$INCLUDE "QWinIni.INC"

DECLARE SUB init
DECLARE SUB OpenClick
DECLARE SUB CloseClick
DECLARE SUB SendClick
DECLARE SUB ComError(strErrorMessage AS STRING)
DECLARE SUB PortOpen
DECLARE SUB PortClosed
DECLARE SUB StringWritten
DECLARE SUB StringRead

DIM strdwBaud    AS STRING
DIM strbParity   AS STRING
DIM strbDataBits AS STRING
DIM strbStopBits AS STRING

DIM strPort   AS STRING
DIM dwBaud    AS DWORD
DIM bParity   AS BYTE
DIM bDataBits AS BYTE
DIM bStopBits AS BYTE

DIM sentence1 as string
DIM sentence2 as string
DIM sentence3 as string
DIM sentence4 as string
DIM sentence5 as string
DIM autostart as string
DIM distancestr as string
dim typelog as string
      
DIM MyPort AS COMPORT
MyPort.OnComError     = ComError
MyPort.OnOpen         = PortOpen
MyPort.OnClose        = PortClosed
MyPort.OnWriteString  = StringWritten
MyPort.OnReadString   = StringRead

' ------------------------------------
' initialisation
' ------------------------------------
sub init
 ini.load(".\gpslog.ini")
 strPort = ini.get("GPSConf","port","COM4")
 strdwBaud = ini.get("GPSConf","bps","4800")
 dwBaud = VAL(strdwBaud)
 strbParity = ini.get("GPSConf","parity","ODDPARITY")
 SELECT CASE strbParity
  CASE "NOPARITY"
   bParity = NOPARITY
  CASE "ODDPARITY"
   bParity = ODDPARITY
  CASE "EVENPARITY"
   bParity = EVENPARITY
  CASE "MARKPARITY"
   bParity = MARKPARITY
  CASE "SPACEPARITY"
   bParity = SPACEPARITY  
 END SELECT
 strbDataBits = ini.get("GPSConf","databits","8")
 bDataBits = VAL(strbDataBits)
 strbStopBits = ini.get("GPSConf","stopbit","ONESTOPBIT")
 SELECT CASE strbStopBits
  CASE "ONESTOPBIT"
   bStopBits = ONESTOPBIT
  CASE "ONE5STOPBITS"
   bStopBits = ONE5STOPBITS
  CASE "TWOSTOPBITS"
   bStopBits = TWOSTOPBITS
 END SELECT
 sentence1 = ini.get("GPSActivate","sentence1","")
 sentence2 = ini.get("GPSActivate","sentence2","")
 sentence3 = ini.get("GPSActivate","sentence3","")
 sentence4 = ini.get("GPSActivate","sentence4","")
 sentence5 = ini.get("GPSActivate","sentence5","")
 autostart = ini.get("GPSLogs","autostart","true")
 distancestr = ini.get("GPSLogs","distance","0")
 typelog = ini.get("GPSLogs","typelog","1")
end sub

' ------------------------------------
' Ouverture du port en coute
' ------------------------------------
SUB OpenClick
'Settings  
MyPort.Port     = strPort
MyPort.BaudRate = dwBaud
MyPort.Parity   = bParity
MyPort.DataBits = bDataBits
MyPort.StopBits = bStopBits
'Open COM Port
MyPort.Open
END SUB

' ------------------------------------
' rcupre un champ NMEA
' ------------------------------------
function NMEAField ($S AS STRING, $TOKEN AS STRING, PosField AS INTEGER) AS STRING
  DIM TokenPos AS Integer
  DIM TokenCRPos AS Integer
  TokenPos = instr(0, $S,$TOKEN)
  TokenCRPos = instr(TokenPos, $S,CHR$(13)+CHR$(10))
  $S = MID$($S,TokenPos, TokenCRPos-TokenPos)
  NMEAField =  FIELD$($S, ",",PosField)
end function

' ------------------------------------
' Ecoute le port et affiche
' ------------------------------------
SUB SendClick
 DIM BytesRead AS DWORD
 DIM $StringRead AS String
 DIM oldpoint(2) AS SINGLE
 DIM newpoint(2) AS SINGLE
 DIM distance AS SINGLE
 oldpoint(0)=0
 oldpoint(1)=0
 newpoint(0)=0
 newpoint(1)=0
 distance = 0
 MyPort.ReadBufSize=65536 
 MyPort.WriteString("$PSRF" + CHR$(13) +CHR$(10), 0)
 WHILE ((MyPort.BytesNotRead > 0) and (MyPort.Connected=TRUE) and (inkey$ <>"q"))
  $StringRead = MyPort.ReadString(MyPort.BytesNotRead, 500)
  if (distance>=val(distancestr)) then
   select case typelog
    case "1"
     if (NMEAField($StringRead, "GGA", 3)<>"") then
      print $stringread
      oldpoint(0) = newpoint(0)
      oldpoint(1) = newpoint(1)
      newpoint(0) = val(NMEAField($StringRead, "GGA", 3))
      newpoint(1) = val(NMEAField($StringRead, "GGA", 5))
     end if
    case "2"
       if (NMEAField($StringRead, "GGA", 7)<>"0" and NMEAField($StringRead, "GGA", 3)<>"") then
      print NMEAField($StringRead, "GGA", 3)&NMEAField($StringRead, "GGA", 4)+" , "+NMEAField($StringRead, "GGA", 5)&NMEAField($StringRead, "GGA", 6)&" , "&NMEAField($StringRead, "GGA", 10)&NMEAField($StringRead, "GGA", 11)
      oldpoint(0) = newpoint(0)
      oldpoint(1) = newpoint(1)
      newpoint(0) = val(NMEAField($StringRead, "GGA", 3))
      newpoint(1) = val(NMEAField($StringRead, "GGA", 5))
     end if
      case "3"
     if (NMEAField($StringRead, "GGA", 7)<>"0" and NMEAField($StringRead, "GGA", 3)<>"") then
      oldpoint(0) = newpoint(0)
      oldpoint(1) = newpoint(1)
      newpoint(0) = val(NMEAField($StringRead, "GGA", 3))
      newpoint(1) = val(NMEAField($StringRead, "GGA", 5))
      distance = sqr((oldpoint(0)-newpoint(0))*(oldpoint(0)-newpoint(0))+(oldpoint(1)-oldpoint(1))*(oldpoint(1)-oldpoint(1)))
      print NMEAField($StringRead, "GGA", 3)&NMEAField($StringRead, "GGA", 4)&" , "&NMEAField($StringRead, "GGA", 5)&NMEAField($StringRead, "GGA", 6)&" , "&str$(distance)
     end if
   end select
  end if
  MyPort.WriteString("$PSRF" + CHR$(13) +CHR$(10), 500)
  if sentence1<>"" then
  MyPort.WriteString(sentence1 + CHR$(13) +CHR$(10), 500)
  end if
  if sentence2<>"" then
  MyPort.WriteString(sentence2 + CHR$(13) +CHR$(10), 500)
  end if
  if sentence3<>"" then
  MyPort.WriteString(sentence3 + CHR$(13) +CHR$(10), 500)
  end if
  if sentence4<>"" then
  MyPort.WriteString(sentence4 + CHR$(13) +CHR$(10), 500)
  end if
  if sentence5<>"" then
  MyPort.WriteString(sentence5 + CHR$(13) +CHR$(10), 500)
  end if
  
  doevents
 WEND
 IF MyPort.Connected=TRUE THEN
  MyPort.Close
 END IF
END SUB


SUB CloseClick
 IF MyPort.Connected=TRUE THEN
  MyPort.Close
 END IF
END SUB


SUB ComError (strErrorMessage AS STRING)
 SHOWMESSAGE strErrorMessage
END SUB

SUB PortOpen
END SUB

SUB PortClosed
END SUB

SUB StringWritten
END SUB

SUB StringRead
END SUB


init

if autostart="false" then
Print "Waiting ! Please press a key to begin"
do
doevents
loop until inkey$ <>""
end if

openclick
SendClick
